PROGRAM xpkaia
 
! Code converted using TO_F90 by Alan Miller
! Date: 2001-07-09  Time: 20:44:01
 
!======================================================================
!     Sample driver program for pikaia.f
!======================================================================

USE Genetic_Algorithm
IMPLICIT NONE
INTEGER             :: seed, STATUS
INTEGER, PARAMETER  :: n = 2
REAL                :: ctrl(12), x(n), f

INTERFACE
  FUNCTION twod(n, x) RESULT(fn_val)
    IMPLICIT NONE
    INTEGER, INTENT(IN)  :: n
    REAL, INTENT(IN)     :: x(:)
    REAL                 :: fn_val
  END FUNCTION twod
END INTERFACE

! EXTERNAL twod

!        (twod is an example fitness function, a smooth 2-d landscape)

!     First, initialize the random-number generator

WRITE (*, '(A)', ADVANCE='NO') ' Random number seed (I*4)? '
READ (*,*) seed
CALL rninit(seed)

!     Set control variables (use defaults)
ctrl(1:12) = -1
ctrl(2) = 50

!     Now call pikaia
CALL pikaia(twod,n,ctrl,x,f,STATUS)

!     Print the results
WRITE (*,*) ' status: ', STATUS
WRITE (*,*) '      x: ', x
WRITE (*,*) '      f: ', f
WRITE (*,5000) ctrl

STOP

5000 FORMAT ('    ctrl: ', 6F9.5 / t11, 6F9.5)
END PROGRAM xpkaia

!*********************************************************************

FUNCTION twod(n,x) RESULT(fn_val)
!=====================================================================
!     Compute sample fitness function (2-d landscape)
!=====================================================================

IMPLICIT NONE
!     Input:
INTEGER, INTENT(IN)  :: n
REAL, INTENT(IN)     :: x(:)

!     Output
REAL                 :: fn_val

!     Constant

REAL, PARAMETER     :: pi = 3.1415926536, sigma2 = 0.15
INTEGER, PARAMETER  :: nn = 9

!     Local
REAL :: rr

IF (x(1) > 1. .OR. x(2) > 1.) STOP
rr = SQRT((0.5 - x(1))**2 + (0.5 - x(2))**2)
fn_val = COS(rr*nn*pi)**2 * EXP(-rr**2/sigma2)

RETURN
END FUNCTION twod
